###############################################################################
# Awards.pm                                                                   #
###############################################################################
# Member Awards                                                               #
# Author: Derek Barnstorm                                                     #
# Updated to 2.7.00 by Deborah Rorabaugh (Dandello)                           #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2017 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use strict;
use warnings;
our $VERSION = '2.7.00';

our $awardsplver = 'YaBB 2.7.00 $Revision: 0.3 $';
our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

our ( $vardir, $modimgurl, $memberdir, $yymain, $user, $en_awards, $yytitle, %INFO, $awards_name,
 $tem_show_awards, $award_title, $uid, $tem_awards_2, %link, $tem_awards, $tem_row_award_2, $awards_admin,
 $tem_all_awards, $tem_award_row, %FORM, $tem_awardsname, $iamadmin, $iamgmod, $yynavigation, $en_awards_gmod,
 $tem_award_page, %useraccount, $date, $username, $en_awards_im, $messageid, $awards_imtext, $mbname, $yysetlocation, 
 $scripturl, $awards_imsubject, $tem_award_edit, $user_award_reason, $user_award_date, $user_award_who,
);

if ( -e ("$vardir/Mods/AwardSettings.txt") ) { require "$vardir/Mods/AwardSettings.txt"; }
if ( !$en_awards ) { fatal_error('not_allowed'); }

load_language('Mods/Awards');
get_template('Mods/Awards');

sub LoadAwards {
    our ($UAWARDS);
    fopen( 'UAWARDS', '<', "$vardir/Mods/Awards.txt" )
      || fatal_error( 'cannot_open', "$vardir/Mods/Awards.txt", 1 );
    my @awards = <$UAWARDS>;
    fclose('UAWARDS');

    return @awards
}

sub Awards {
    my @awards = LoadAwards();
    $yytitle = $awards_name;
    my $total_awards = @awards;

    my $show_awards = q{};
    my $award_row = q{};
    if ($total_awards) {
        if ( $INFO{'id'} ) {
            my $id = $INFO{'id'};
            my ($award_title, $award_image, $award_desc);
            for my $award (@awards) {
                if ( $award =~ /\b$id\b/ ) {
                    ( undef, undef, $award_title, $award_image, $award_desc ) =
                      split /[|]/xsm, $award;
                }
                $award_image ||= q{};
                $award_title ||= q{};
                $award_desc  ||= q{};
                $show_awards = $tem_show_awards;
                $show_awards =~
                  s/\Q{yabb awardimg}\E/$modimgurl\/Awards\/$award_image/gxsm;
                $show_awards =~ s/\Q{yabb awardtitle}\E/$award_title/gxsm;
                $show_awards =~ s/\Q{yabb awarddesc}\E/$award_desc/gxsm;
            }
            $award_title ||= q{};
            $yytitle .= qq~ - $award_title~;
            $yymain = $tem_awards;
        }
        elsif ( $INFO{'username'} ) {
            $user = $INFO{'username'};
            if ( !LoadUser($user) ) { fatal_error('no_profile_exists'); }
            $yytitle .= qq~ - ${$uid.$user}{'realname'}~;
            our ($UAWARDS);
            fopen( 'UAWARDS', '<', "$memberdir/$user.awards" );
            my @getawards = <$UAWARDS>;
            fclose('UAWARDS');
            foreach my $user_award ( sort { $b cmp $a } @getawards ) {
                chomp $user_award;
                my (
                    $user_award_date,   $user_award_id,
                    $user_award_reason, $user_award_who
                ) = split /[|]/xsm, $user_award;
                load_user($user_award_who);
				my ($award_id, $award_title, $award_image);
                my $who_name        = $link{$user_award_who};
                $user_award_date = timeformat($user_award_date);
                for my $award (@awards) {
                    if ( $award =~ /\b$user_award_id\b/ ) {
                        ( undef, $award_id, $award_title, $award_image, undef )
                          = split /[|]/xsm, $award;
                    }
                }
                if ( $user_award_id eq $award_id ) {
                    $award_row .= $tem_row_award_2;
                    $award_row =~ s/{user_award_id}/$user_award_id/gsm;
                    $award_row =~ s/{award_title}/$award_title/gsm;
                    $award_row =~ s/{user_award_reason}/$user_award_reason/gsm;
                    $award_row =~ s/{user_award_date}/$user_award_date/gsm;
                    $award_row =~ s/{who_name}/$who_name/gsm;
                    $award_row =~ s/{awards_admin}/$awards_admin/gsm;
                    $award_row =~
                      s/{yabb awardimg}/$modimgurl\/Awards\/$award_image/gsm;
                }
            }
            $yymain = $tem_awards_2;
        }
        else {
            for my $award ( sort { $a cmp $b } @awards ) {
                chomp $award;
                my ( undef, $award_id, $award_title, $award_image, $award_desc ) =
                  split /[|]/xsm, $award;
                $award_row .= $tem_award_row;
                $award_row =~ s/{award_id}/$award_id/gsm;
                $award_row =~ s/{award_title}/$award_title/gsm;
                $award_row =~ s/{yabb awarddesc}/$award_desc/gsm;
                $award_row =~
                  s/{yabb awardimg}/$modimgurl\/Awards\/$award_image/gsm;
            }
            $yymain = $tem_all_awards;
        }
    }
    else {
        $yymain = $tem_awardsname;
    }
    $award_title ||= q{};
    $yymain =~ s/{yabb awardsname}/$awards_name/gsm;
    $yymain =~ s/{total_awards}/$total_awards/gsm;
    $yymain =~ s/{yabb award_row}/$award_row/gsm;
    $yymain =~ s/{yabb awardtitle}/$award_title/gsm;
    $yymain =~ s/{yabb show_awards}/$show_awards/gsm;

    $yynavigation = qq~&rsaquo; $awards_name~;
    template();

}

sub AwardMember {

    if ( !$iamadmin && ( !$iamgmod || !$en_awards_gmod ) ) {
        fatal_error('not_allowed');
    }

    $user = $INFO{'username'};
    if ( !load_user($user) ) { fatal_error('no_profile_exists'); }

    my @awards = LoadAwards();

    my $show_awards = q{};
    for my $award (@awards) {
        chomp $award;
        my ( undef, $award_id, $award_title, $award_image, $award_desc ) =
          split( /[|]/xsm, $award );
        $show_awards .= qq~<option value="$award_id">$award_title</option>\n~;
    }

    $yymain .= $tem_award_page;
    $yymain =~ s/\Q{yabb awards_name}\E/$awards_name/gxsm;
	{ no strict qw(refs);
        $yymain =~ s/\Q{yabb id}\E/${$uid.$user}{'realname'}/gxsm;
	}
    $yymain =~ s/\Q{yabb show_awards}\E/$show_awards/gxsm;
    $yymain =~ s/\Q{yabb username}\E/$useraccount{$user}/gxsm;

	{ no strict qw(refs);
        $yytitle      = "$awards_name - ${$uid.$user}{'realname'}";
	}
    $yynavigation = qq~&rsaquo; $awards_name~;
    template();
}

sub AwardMember2 {

    if ( !$iamadmin && ( !$iamgmod || !$en_awards_gmod ) ) {
        fatal_error('not_allowed');
    }

    $user = $FORM{'username'};
    if ( !load_user($user) ) { fatal_error('no_profile_exists'); }

    my $award_id     = $FORM{'award'};
    my $award_reason = $FORM{'award_reason'};

    if ( !$FORM{'award'} )         { fatal_error("no_award"); }
    if ( !$FORM{'award_reason'} ) { fatal_error("no_award_reason"); }

    our($AWARDS);
    fopen( 'AWARDS', '>>', "$memberdir/$user.awards" );
    print {$AWARDS} "$date|$award_id|$award_reason|$username\n";
    fclose('AWARDS');

    if ($en_awards_im) {
        my @awards = LoadAwards();
        for my $award (@awards) {
            if ( $award =~ /\b$award_id\b/ ) {
                ( undef, undef, $award_title, undef, undef ) = split /[|]/xsm,
                  $award;
            }
        }
        require Sources::MyCenter;
        $messageid = getnewid();
        $awards_imtext =~ s/{award}/$award_title/gsm;
        $awards_imtext =~ s/{reason}/$award_reason/gsm;
        $awards_imtext =~ s/{name}/${$uid.$user}{'realname'}/gsm;
        $awards_imtext =~ s/{myname}/${$uid.$username}{'realname'}/gsm;
        $awards_imtext =~ s/{mbname}/$mbname/gsm;
        our ($INBOX);
        fopen( 'INBOX', '<', "$memberdir/$user.msg" );
        my @inmessages = <$INBOX>;
        fclose('INBOX');
        unshift @inmessages, "$messageid|$username|$user|||$awards_imsubject|$date|$awards_imtext|$messageid|0|$ENV{'REMOTE_ADDR'}|s|u||";
        fopen( 'INBOX', '>', "$memberdir/$user.msg" );
        print {$INBOX} @inmessages;
        fclose('INBOX');
        update_ims( $user, $messageid, 'messagein' );
    }

    $yysetlocation =
      qq~$scripturl?action=viewprofile;username=$useraccount{$user}~;
    redirectexit();
}

sub AwardEdit {
    if ( !$iamadmin && ( !$iamgmod || !$en_awards_gmod ) ) {
        fatal_error('not_allowed');
    }
    my $user = $INFO{'username'};
    if ( !load_user($user) ) { fatal_error('no_profile_exists'); }

    my $id = $INFO{'id'};
    my $award_edit = q{};
    my $show_awards = q{};

    our ($UAWARDS);
    fopen( 'UAWARDS', '<', "$memberdir/$user.awards" );
    my @getawards = <$UAWARDS>;
    fclose('UAWARDS');

    my @awards = LoadAwards();

    for my $award (@awards) {
        chomp $award;
        my ( undef, $award_id, $award_title, $award_image, $award_desc ) =
          split /[|]/xsm, $award;
        my $sel_award = q{};
        for my $user_award (@getawards) {
            chomp $user_award;
            if ( $user_award =~ /\b$id\b/ ) {
                $award_edit = $user_award;
                last;
            }
        }
        my (
            $user_award_date,   $user_award_id,
            $user_award_reason, $user_award_who
        ) = split /[|]/xsm, $award_edit;
        if ( $user_award_id eq $award_id ) {
            $sel_award = qq~ selected="selected"~;
        }
        $show_awards .=
          qq~<option value="$award_id"$sel_award>$award_title</option>\n~;
    }

    $yymain = $tem_award_edit;
    $yymain =~ s/{yabb awards_name}/$awards_name/gsm;
    $yymain =~ s/{yabb id}/${$uid.$user}{'realname'}/gsm;
    $yymain =~ s/{yabb show_awards}/$show_awards/gsm;
    $yymain =~ s/{yabb username}/$useraccount{$user}/gsm;
    $yymain =~ s/{yabb show_awards}/$show_awards/gsm;
    $yymain =~ s/{yabb show_reason}/$user_award_reason/gsm;
    $yymain =~ s/{user_award_date}/$user_award_date/gsm;
    $yymain =~ s/{award_who}/$user_award_who/gsm;

    $yytitle      = "$awards_name - ${$uid.$user}{'realname'}";
    $yynavigation = qq~&rsaquo; $awards_name~;
    template();

}

sub AwardEdit2 {

    if ( !$iamadmin && ( !$iamgmod || !$en_awards_gmod ) ) {
        fatal_error('not_allowed');
    }

    $user = $FORM{'username'};
    if ( !load_user($user) ) { fatal_error('no_profile_exists'); }

    my $award_id     = $FORM{'award'};
    my $award_reason = $FORM{'award_reason'};
    my $award_date   = $FORM{'award_date'};
    my $award_who    = $FORM{'award_who'};

    if ( $FORM{'award'} eq q{} )        { fatal_error('no_award'); }
    if ( $FORM{'award_reason'} eq q{} ) { fatal_error('no_award_reason'); }

    our ($AWARDS);
    fopen( 'AWARDS', '<', "$$memberdir/$user.awards" )
      || fatal_error( 'cannot_open', "$memberdir/$user.awards", 1 );
    my @awards = <AWARDS>;
    fclose('AWARDS');

    my @award = grep ( !/$award_date/, @awards );
    push( @award, "$award_date|$award_id|$award_reason|$award_who" );
    my $award = join( q{}, @award );

    fopen( 'AWARDS', '>', "$memberdir/$user.awards" )
      || fatal_error( 'cannot_open', "$memberdir/$user.awards", 1 );
    print {$AWARDS} "$award\n";
    fclose('AWARDS');

    $yysetlocation =
      qq~$scripturl?action=viewprofile;username=$useraccount{$user}~;
    redirectexit();
}

sub AwardDelete {

    if ( !$iamadmin && ( !$iamgmod || !$en_awards_gmod ) ) {
        fatal_error('not_allowed');
    }

    $user = $INFO{'username'};
    if ( !load_user($user) ) { fatal_error('no_profile_exists'); }

    our ($AWARDS);
    fopen( 'AWARDS', '<', "$memberdir/$user.awards" )
      || fatal_error( 'cannot_open', "$memberdir/$user.awards", 1 );
    my @awards = <$AWARDS>;
    fclose('AWARDS');

    fopen( 'AWARDS', '>', "$memberdir/$user.awards" )
      || fatal_error( 'cannot_open', "$memberdir/$user.awards", 1 );
    print {$AWARDS} grep ( !/$INFO{'id'}/, @awards );
    fclose('AWARDS');

    $yysetlocation =
      qq~$scripturl?action=viewprofile;username=$useraccount{$user}~;
    redirectexit();
}

1;
